﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	
	public class Laser_HitDetection extends Sprite
	{
		var laserGun:Sprite; //Instance of laserGenerator_MC
		var obstacles:Sprite; //Instance of obstacles_MC
		
		var laser:Sprite;		

		var startX:Number; //x starting point of laser
		var startY:Number; //y starting point of laser
		var endX:Number; //x end point of laser
		var endY:Number; //y end point of laser
		
		var rad:Number = Math.PI/180; //Used to calculate angle in radians
		var maxDist:Number = 250; //maximum distance to be travelled by the laser
		var adjustedDist:Number; //new maximum distance if any obstacle comes in a way
		
		var tolerance:Number = 1;
		
		//Constructor
		public function Laser_HitDetection()
		{			
			CreateLaserGun();			
			CreateObstacles();
			ProjectLaser();

			addEventListener( Event.ENTER_FRAME, LaserGunRotation );
		}

		//Get and place laser generator from library
		public function CreateLaserGun():void
		{
			laserGun = new laserGenerator_MC(); //Get it from the library
			addChild(laserGun);

			//Place laser generator at the centre of the stage
			laserGun.x = stage.stageWidth / 2;
			laserGun.y = stage.stageHeight / 2;
		}
		
		//Get and place obstacles from library
		public function CreateObstacles():void
		{
			obstacles = new obstacles_MC(); //Get it from the library
			addChild(obstacles);
			
			//Place obstacles at the centre of the stage
			obstacles.x = stage.stageWidth / 2;
			obstacles.y = stage.stageHeight / 2;
		}

		//Project a laser from laser generator device
		public function ProjectLaser():void
		{
			laser = new Sprite();
			addChild(laser);
		
			//Set origin of the laser as the centre of the laser gun
			startX = laserGun.x;
			startY = laserGun.y;
		}
		
		//Hit Test
		public function HitTest():void
		{
			for (adjustedDist = 0; adjustedDist < maxDist; adjustedDist ++)
			{
				//Trigonometry to aim the laser w.r.t laser gun's rotation
				endX = laserGun.x + Math.cos(laserGun.rotation * rad) * adjustedDist;
				endY = laserGun.y + Math.sin(laserGun.rotation * rad) * adjustedDist;
		
				//calculate hit test
				if (obstacles.hitTestPoint(endX,endY,true))
				{
					break;
				}
			}
		
			//Draw laser
			laser.graphics.clear(); //Removes the old laser projection
			laser.graphics.lineStyle( 1, 0xFF0000 );
			laser.graphics.moveTo( startX, startY );
			laser.graphics.lineTo ( endX, endY );
		}
		
		//Rotate Laser Gun
		public function LaserGunRotation( evt:Event ):void
		{
			laserGun.rotation += 0.5;

			HitTest();
		}
	}
}